//
// = FILENAME
//    MineClient.hh
//
// = FUNCTION
//
// = AUTHOR(S)
//    Patric Jensfelt
//
// = COPYRIGHT
//    Copyright (c) 2006 Patric Jensfelt
//
/*----------------------------------------------------------------------*/

#ifndef MineClient_hh
#define MineClient_hh

#include "MineAgent.hh"

class MineClient {
public:
  /// Constructor for the MineClient
  MineClient(MineAgent &agent);

  /// Call this function to play the game
  void playGame(const std::string &hostname, int port);

protected:
  /// Connect to minesweep server
  bool connect(const std::string &hostname, int port);
    
  /// Disconnect to minesweep server
  bool disconnect();

  /// This function will block until there is a message
  /// @return "" if no message
  std::string waitForMsg();

  /// Sned a message to the server
  /// @return true if sending ok, else false
  bool sendMsg(const std::string &msg);

protected:
  MineAgent *m_Agent;
  int m_Socket;
};
 
#endif // MineClient_hh
